﻿#include <windows.h>

#define IDC_BUTTON     1
#define IDC_EDIT       2
#define IDC_CHECKBOX   3
#define IDC_STATIC     4

#define IDM_NOWY       1
#define IDM_ZAPISZ     2
#define IDM_WCZYTAJ    3
#define IDM_ZAMKNIJ    4

#define IDM_KOPIUJ     5
#define IDM_WYTNIJ     6
#define IDM_WKLEJ      7

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
switch(msg)
    {
		static HWND hButton, hEdit, hCheckBox, hStatic;
		static HMENU hMenu, hFileMenu, hEditMenu;

		case WM_CREATE:
			hEdit = CreateWindow(TEXT("EDIT"), TEXT("Wpisz tu tekst i wciśnij przycisk"), 
				WS_CHILD | WS_VISIBLE | ES_MULTILINE | ES_AUTOVSCROLL| WS_VSCROLL | WS_BORDER ,
				10, 10, 470, 240 , hwnd, (HMENU)IDC_EDIT, (HINSTANCE)GetWindowLong(hwnd, GWL_HINSTANCE), NULL);
			hStatic = CreateWindow(TEXT("STATIC"), TEXT("Hello world"), WS_CHILD | WS_VISIBLE | WS_BORDER,
				10, 260, 470, 240 , hwnd, (HMENU)IDC_STATIC, (HINSTANCE)GetWindowLong(hwnd, GWL_HINSTANCE), NULL);
			hButton = CreateWindow(TEXT("BUTTON"), TEXT("Kopiuj"), WS_CHILD | WS_VISIBLE,
				10, 510, 100, 30, hwnd, (HMENU)IDC_BUTTON, GetModuleHandle(NULL), NULL);
			hCheckBox = CreateWindow(TEXT("BUTTON"), TEXT("Wlacz/wylacz"), WS_CHILD | WS_VISIBLE | BS_CHECKBOX,
				220, 510, 200, 30, hwnd, (HMENU)IDC_CHECKBOX, (HINSTANCE)GetWindowLong(hwnd, GWL_HINSTANCE), NULL);

			hMenu = CreateMenu();
			hFileMenu = CreateMenu();
			hEditMenu = CreateMenu();
			
			AppendMenu(hFileMenu, MF_STRING, IDM_NOWY, TEXT("&Nowy"));
			AppendMenu(hFileMenu, MF_STRING, IDM_ZAPISZ, TEXT("&Zapisz"));
			AppendMenu(hFileMenu, MF_STRING, IDM_WCZYTAJ, TEXT("&Wczytaj"));
			AppendMenu(hFileMenu, MF_SEPARATOR, 0, NULL);
			AppendMenu(hFileMenu, MF_STRING, IDM_ZAMKNIJ, TEXT("&Zamknij"));
			AppendMenu(hMenu, MF_POPUP, (UINT_PTR)hFileMenu, TEXT("&Plik"));
			
			AppendMenu(hEditMenu, MF_STRING, IDM_KOPIUJ, TEXT("&Kopiuj\tCtrl+C"));
			AppendMenu(hEditMenu, MF_STRING, IDM_WYTNIJ, TEXT("&Wytnij"));
			AppendMenu(hEditMenu, MF_STRING, IDM_WKLEJ, TEXT("&Wklej"));
	
			AppendMenu(hMenu, MF_POPUP, (UINT_PTR)hEditMenu, TEXT("&Edycja"));
			AppendMenu(hMenu, MF_STRING, 2, TEXT("P&omoc"));
			SetMenu(hwnd, hMenu);

			

			break;

		case WM_COMMAND:
			switch LOWORD(wParam)
			{
			case IDC_BUTTON :
				if(HIWORD(wParam) == BN_CLICKED)
				{
					TCHAR *tekst;
					int rozmiar = GetWindowTextLength(hEdit);
					tekst = (TCHAR*)GlobalAlloc(GPTR,  (rozmiar + 1) * sizeof(TCHAR));
					GetWindowText(hEdit, tekst, rozmiar + 1);
					SetWindowText(hStatic, tekst);
					GlobalFree(tekst);
				}

				break;
			
			case IDC_CHECKBOX :
				// MessageBox(NULL, TEXT("Checkbox wcisniety."), TEXT(""), MB_OK);
				if (SendMessage(hCheckBox, BM_GETCHECK, 0, 0) == BST_CHECKED)
					SendMessage(hCheckBox, BM_SETCHECK, BST_UNCHECKED, 0);
				else SendMessage(hCheckBox, BM_SETCHECK, BST_CHECKED, 0);
				LONG style = GetWindowLong(hEdit, GWL_STYLE);
				style ^= WS_DISABLED;
				SetWindowLong(hEdit, GWL_STYLE, style);
				break;
			}
			if (HIWORD(wParam) == 0)
			{
				switch (LOWORD(wParam))
				{
				case IDM_NOWY:
					SendMessage(hEdit, WM_SETTEXT, 0 , (LPARAM)TEXT(""));
					break;
				case IDM_ZAMKNIJ:
					SendMessage(hwnd, WM_CLOSE, 0 , 0);
					break;
				case IDM_KOPIUJ:
					SendMessage(hEdit, WM_COPY, 0 , 0);
					break;
				case IDM_WKLEJ:
					SendMessage(hEdit, WM_PASTE, 0 , 0);
					break;
				case IDM_WYTNIJ:
					SendMessage(hEdit, WM_CUT, 0 , 0);
					break;
				default:
					break;
				}
			
			}

			break;
		case WM_RBUTTONDOWN:
			SetForegroundWindow(hwnd);
			POINT p;
			GetCursorPos(&p);
			TrackPopupMenu(hFileMenu, TPM_RIGHTBUTTON, p.x, p.y, 0, hwnd, NULL);
			break;
		case WM_CLOSE:
            DestroyWindow(hwnd);

        break;
        case WM_DESTROY:
            PostQuitMessage(0);
        break;
        default:
            return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}


int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASSEX wndClass;
	HWND hwnd;
	MSG Msg;

	ZeroMemory(&wndClass, sizeof(wndClass));
	wndClass.cbSize = sizeof(wndClass);
	wndClass.lpszClassName = TEXT("Klasa okien");
	wndClass.hInstance = hInstance;
	wndClass.lpfnWndProc = WndProc;
	wndClass.hbrBackground = (HBRUSH)(COLOR_WINDOW);
	wndClass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndClass.hIconSm = LoadIcon(NULL, IDI_APPLICATION);

	if (!RegisterClassEx(&wndClass))
	{
		MessageBox(NULL, TEXT("Bład rejestrowania klasy okna"), TEXT("Bład"), 
			MB_ICONEXCLAMATION | MB_OK);
		return 0;
	}


	hwnd = CreateWindow(TEXT("Klasa okien"), TEXT("Witaj swiecie"), WS_OVERLAPPEDWINDOW, 10, 10, 500, 600, 
		NULL, NULL, hInstance, NULL);

	if (hwnd == NULL)
	{
		MessageBox(NULL, TEXT("Błšd tworzenia okna!"), TEXT("Bład"),
			MB_ICONEXCLAMATION | MB_OK);
		return 0;
	}

	ShowWindow(hwnd, nCmdShow);
	UpdateWindow(hwnd);

	while(GetMessage(&Msg, NULL, 0, 0) > 0)
    {
        TranslateMessage(&Msg);
        DispatchMessage(&Msg);
    }

	return Msg.wParam;
}